Index: /trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 305)
@@ -534,5 +534,5 @@
       IF (ierr.NE.NF_NOERR) THEN
          PRINT*, 'phyetat0: Lecture echouee pour <totcloudfrac>'
-         CALL abort
+         !CALL abort
       ENDIF
       xmin = 1.0E+20
@@ -541,5 +541,4 @@
       xmax = MAXVAL(totcloudfrac)
       PRINT*,'Cloud fraction <totcloudfrac>:', xmin, xmax
-
 
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 305)
@@ -8,5 +8,5 @@
  
       use radinc_h, only : naerkind
-      use watercommon_h, only : mx_eau_sol, To, RLVTT
+      use watercommon_h, only : mx_eau_sol, To, RLVTT, mH2O
      
       implicit none
@@ -392,6 +392,6 @@
       integer igtest
 
-!     included by RW for pressure broadening broadening study
-      integer gascut
+!     included by RW for runway greenhouse 1D study
+      real muvar(ngridmx,nlayermx+1)
 
 !     included by RW for variable H2O particle sizes
@@ -404,4 +404,5 @@
 !     included by RW for sourceevol
       real ice_initial(ngridmx)!, isoil
+      real delta_ice,ice_tot
       real ice_min(ngridmx)
       save ice_min
@@ -502,5 +503,5 @@
             close(128)
         
-            if(num_run.ne.0.and.mod(num_run,6).eq.0)then
+            if(num_run.ne.0.and.mod(num_run,3).eq.0)then
                print*,'Updating ice at end of this year!'
                ice_update=.true.
@@ -713,17 +714,8 @@
 
               if(kastprof)then
-                 ISR=fract(1)*Fat1AU/dist_star**2/2.0
-
-                 call simpleprof_fn(tsurf,pt,zpopsk,ISR,pplev(1,1))
-                 open(116,file='profpres.out',form='formatted')
-                 open(117,file='proftemp.out',form='formatted')
-                 do l=1,nlayer
-                    write(116,*) pplay(1,l)
-                    write(117,*) pt(1,l)
-                 enddo
-                 close(116)
-                 close(117)
+                 print*,'kastprof should not = true here'
+                 call abort
               endif
-
+              muvar(:,:)=0.0 ! only used for climate evolution for now
 
 !             Option to call scheme once for clear regions, once for cloudy regions (BC)
@@ -731,17 +723,17 @@
 
                  clearsky=.true.
-                 call callcorrk(icount,ngrid,nlayer,pq,nq,qsurf,           &
+                 call callcorrk(ngrid,nlayer,pq,nq,qsurf,           &
                       albedo,emis,mu0,pplev,pplay,pt,                      &
-                      tsurf,fract,dist_star,aerosol,cpp3D,                 &
+                      tsurf,fract,dist_star,aerosol,cpp3D,muvar,           &
                       zdtlw1,zdtsw1,fluxsurf_lw1,fluxsurf_sw1,fluxtop_lw1, &
-                      fluxabs_sw1,fluxtop_dn,reffrad,tau_col1,ptime,pday,  &
+                      fluxabs_sw1,fluxtop_dn,reffrad,tau_col1,             &
                       cloudfrac,totcloudfrac,clearsky,firstcall,lastcall)
 
                  clearsky=.false.
-                 call callcorrk(icount,ngrid,nlayer,pq,nq,qsurf,           &
+                 call callcorrk(ngrid,nlayer,pq,nq,qsurf,           &
                       albedo,emis,mu0,pplev,pplay,pt,                      &
-                      tsurf,fract,dist_star,aerosol,cpp3D,                 &
+                      tsurf,fract,dist_star,aerosol,cpp3D,muvar,           &
                       zdtlw2,zdtsw2,fluxsurf_lw2,fluxsurf_sw2,fluxtop_lw2, &
-                      fluxabs_sw2,fluxtop_dn,reffrad,tau_col2,ptime,pday,  &
+                      fluxabs_sw2,fluxtop_dn,reffrad,tau_col2,             &
                       cloudfrac,totcloudfrac,clearsky,firstcall,lastcall)
 
@@ -767,9 +759,9 @@
 
                  clearsky=.false.
-                 call callcorrk(icount,ngrid,nlayer,pq,nq,qsurf,         &
+                 call callcorrk(ngrid,nlayer,pq,nq,qsurf,         &
                       albedo,emis,mu0,pplev,pplay,pt,                    &
-                      tsurf,fract,dist_star,aerosol,cpp3D,               &
+                      tsurf,fract,dist_star,aerosol,cpp3D,muvar,         &
                       zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
-                      fluxabs_sw,fluxtop_dn,reffrad,tau_col,ptime,pday,  &
+                      fluxabs_sw,fluxtop_dn,reffrad,tau_col,             &
                       cloudfrac,totcloudfrac,clearsky,firstcall,lastcall)
 
@@ -881,5 +873,4 @@
       endif ! of if (callrad)
 
-	
 !-----------------------------------------------------------------------
 !    4. Vertical diffusion (turbulent mixing):
@@ -906,5 +897,5 @@
               zdum1,zdum2,zdh,pdq,zflubid,           &
               zdudif,zdvdif,zdhdif,zdtsdif,q2,       &
-              zdqdif,zdqsdif)
+              zdqdif,zdqsdif,lastcall)
 
          do l=1,nlayer
@@ -1143,5 +1134,5 @@
          endif
 
-         call condens_co2cloud(ngrid,nlayer,nq,ptimestep,   &
+         call condense_cloud(ngrid,nlayer,nq,ptimestep,   &
               capcal,pplay,pplev,tsurf,pt,                  &
               pphi,pdt,pdu,pdv,zdtsurf,pu,pv,pq,pdq,        &
@@ -1213,5 +1204,5 @@
                call evap(ptimestep,pt,pq,pdq,pdt,dqevap,dtevap,qevap,tevap)
                DO l = 1, nlayer  
-                  DO ig = 1, ngrid        	
+                  DO ig = 1, ngrid 
                      pdq(ig,l,igcm_h2o_vap) = pdq(ig,l,igcm_h2o_vap)+dqevap(ig,l)
                      pdq(ig,l,igcm_h2o_ice) = pdq(ig,l,igcm_h2o_ice)-dqevap(ig,l)
@@ -1626,9 +1617,7 @@
 
 !     Increment surface temperature
-      if(.not.kastprof)then
-         do ig=1,ngrid
-            tsurf(ig)=tsurf(ig)+ptimestep*zdtsurf(ig) 
-         enddo
-      endif
+      do ig=1,ngrid
+         tsurf(ig)=tsurf(ig)+ptimestep*zdtsurf(ig) 
+      enddo
 
 !     Compute soil temperatures and subsurface heat flux
@@ -1783,17 +1772,4 @@
          endif
 
-         if(kastprof)then ! for f(p,T) computation (not needed in universal model)
-            open(15,file='ene_bal.out',form='formatted',access='append')
-            write(15,*) pplev(1,1), Tsurf(1), ISR, OLR, ASR
-            close(15)
-            open(16,file='Seff.out',form='formatted')
-            write(16,*) OLR/ASR
-            close(16)
-            open(17,file='alb.out',form='formatted')
-            write(17,*) 1.0-ASR/ISR
-            close(17)
-            call abort
-         endif
-
       endif
 
@@ -1830,10 +1806,13 @@
          do ig=1,ngrid
             do l=1,nlayer
-               reffcol(ig,1) = reffcol(ig,1) + zq(ig,l,igcm_co2_ice) * reffrad(ig,l,1) *    &
-                    (pplev(ig,l) - pplev(ig,l+1)) / g
+               if(co2cond)then
+                  reffcol(ig,1) = reffcol(ig,1) + zq(ig,l,igcm_co2_ice) * &
+                                  reffrad(ig,l,1) *    &
+                                  (pplev(ig,l) - pplev(ig,l+1)) / g
+               endif
                if(water)then
-               reffcol(ig,2) = reffcol(ig,2) + zq(ig,l,igcm_h2o_ice) * reffrad(ig,l,2) *    &
-                    (pplev(ig,l) - pplev(ig,l+1)) / g
-
+                  reffcol(ig,2) = reffcol(ig,2) + zq(ig,l,igcm_h2o_ice) * &
+                                  reffrad(ig,l,2) *    &
+                                  (pplev(ig,l) - pplev(ig,l+1)) / g
                endif
             enddo
@@ -1923,23 +1902,38 @@
 !           Update surface ice distribution to iterate to steady state if requested
             if(ice_update)then
+
                do ig = 1, ngrid
 
-                  ! if ice amount is declining, set it to zero
-                  if(qsurf_hist(ig,igcm_h2o_ice).lt.ice_initial(ig))then
-                     qsurf_hist(ig,igcm_h2o_ice)=0.0 
-                     qsurf_hist(ig,igcm_h2o_vap)=0.0
+                  delta_ice = (qsurf(ig,igcm_h2o_ice)-ice_initial(ig))
+
+                  ! add one hundred years/timesteps of evolution
+                  qsurf_hist(ig,igcm_h2o_ice) = &
+                     qsurf_hist(ig,igcm_h2o_ice) + delta_ice*100.0 
+
+                  ! if ice has gone -ve, set to zero
+                  if(qsurf_hist(ig,igcm_h2o_ice).lt.0.0)then
+                     qsurf_hist(ig,igcm_h2o_ice) = 0.0 
+                     qsurf_hist(ig,igcm_h2o_vap) = 0.0
                   endif
- 
-                  ! if ice amount is increasing and was never less than 0.5 kg/m2,
-                  ! set value in gridbox to 1x10^3 kg/m2
-                  !if(qsurf_hist(ig,igcm_h2o_ice).gt.0.0 .and. ice_min(ig).gt.0.5)then
-                  if(qsurf_hist(ig,igcm_h2o_ice).gt.ice_initial(ig))then
-                     if(ice_min(ig).gt.0.5)then ! ignore seasonal ice
-                        qsurf_hist(ig,igcm_h2o_ice)=1.e3
-                        qsurf_hist(ig,igcm_h2o_vap)=0.0
-                     endif
+
+                  ! set maximum to ice
+                  if(qsurf_hist(ig,igcm_h2o_ice).gt.1.e3)then
+                     qsurf_hist(ig,igcm_h2o_ice) = 1.e3 
+                     qsurf_hist(ig,igcm_h2o_vap) = 0.0
                   endif
 
                enddo
+
+               ! enforce ice conservation
+               ice_tot=0.0
+               do ig = 1, ngrid
+                  ice_tot = ice_tot + qsurf_hist(ig,igcm_h2o_ice)*area(ig)
+               enddo
+               do ig = 1, ngrid
+                  qsurf_hist(ig,igcm_h2o_ice) = qsurf_hist(ig,igcm_h2o_ice)*(icesrf/ice_tot)
+               enddo
+
+
+
             endif
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 305)
@@ -74,4 +74,8 @@
 
 !      integer, parameter :: L_NPREF   = 8
+!      integer, parameter :: L_NTREF   = 11
+!      integer, parameter :: L_REFVAR  = 8   ! N2_H2Ovar
+
+!      integer, parameter :: L_NPREF   = 8
 !      integer, parameter :: L_NTREF   = 5
 !      integer, parameter :: L_REFVAR  = 1   ! therm_test2
@@ -109,7 +113,6 @@
       ! equivalent temperatures are 1/10 of these values
       integer, parameter :: NTstar = 500
-!      integer, parameter :: NTstop = 9000 ! for hotstuff runs
-      integer, parameter :: NTstop = 6000 ! for GJ581d / earlymars runs
-!      integer, parameter :: NTstop = 10000 ! for H2 warming runs
+      integer, parameter :: NTstop = 9000 ! new default for all non hot Jupiter runs
+      !integer, parameter :: NTstop = 6000 ! for GJ581d / earlymars runs
 
 ! Maximum number of grain size classes
Index: /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 305)
@@ -493,17 +493,12 @@
 
       if(autozlevs)then
-         if(kastprof)then
-            Hscale=10.0
-            Hmax=400.0
-         else
             
-            open(91,file="z2sig.def",form='formatted')
-            read(91,*) Hscale
-            DO ilayer=1,nlayer-2
-               read(91,*) Hmax
-            enddo
-            close(91)
- 
-         endif
+         open(91,file="z2sig.def",form='formatted')
+         read(91,*) Hscale
+         DO ilayer=1,nlayer-2
+            read(91,*) Hmax
+         enddo
+         close(91)
+ 
             
          print*,'Hmax = ',Hmax,' km'
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 305)
@@ -0,0 +1,279 @@
+      subroutine writediagspecIR(ngrid,nom,titre,unite,dim,px)
+
+!  Ecriture de variables diagnostiques au choix dans la physique 
+!  dans un fichier NetCDF nomme  'diagfi'. Ces variables peuvent etre
+!  3d (ex : temperature), 2d (ex : temperature de surface), ou
+!  0d (pour un scalaire qui ne depend que du temps : ex : la longitude
+!  solaire)
+!  Dans la version 2000, la periode d'ecriture est celle de 
+!  "ecritphy " regle dans le fichier de controle de run :  run.def
+!
+!    writediagfi peut etre appele de n'importe quelle subroutine
+!    de la physique, plusieurs fois. L'initialisation et la creation du
+!    fichier se fait au tout premier appel.
+!
+! WARNING : les variables dynamique (u,v,t,q,ps)
+!  sauvees par writediagfi avec une
+! date donnee sont legerement differentes que dans le fichier histoire car 
+! on ne leur a pas encore ajoute de la dissipation et de la physique !!!
+! IL est  RECOMMANDE d'ajouter les tendance physique a ces variables
+! avant l'ecriture dans diagfi (cf. physiq.F)
+!  
+!
+!  parametres (input) :
+!  ----------
+!      ngrid : nombres de point ou est calcule la physique
+!                (ngrid = 2+(jjm-1)*iim - 1/jjm)
+!                 (= nlon ou klon dans la physique terrestre)
+!      
+!      unit : unite logique du fichier de sortie (toujours la meme)
+!      nom  : nom de la variable a sortir (chaine de caracteres)
+!      titre: titre de la variable (chaine de caracteres)
+!      unite : unite de la variable (chaine de caracteres)
+!      px : variable a sortir (real 0, 2, ou 3d)
+!      dim : dimension de px : 0, 2, ou 3 dimensions
+!
+!=================================================================
+!
+!      This is a modified version that accepts spectrally varying input
+!      RW (2010)
+!
+!=================================================================
+ 
+! Addition by RW (2010) to allow OLR to be saved in .nc format
+      use radinc_h, only : L_NSPECTI
+
+      implicit none
+
+! Commons
+#include "dimensions.h"
+#include "dimphys.h"
+#include "paramet.h"
+#include "control.h"
+#include "comvert.h"
+#include "comgeom.h"
+#include "description.h"
+#include "netcdf.inc"
+#include "temps.h"
+#include "surfdat.h"
+
+! Arguments on input:
+      integer ngrid
+      character (len=*) :: nom,titre,unite
+      integer dim
+      real px(ngrid,L_NSPECTI)
+
+! Local variables:
+
+!      real dx3(iip1,jjp1,llm) ! to store a 3D data set
+!      real dx2(iip1,jjp1)     ! to store a 2D (surface) data set
+!      real dx0
+
+      real date
+
+      REAL phis(ip1jmp1)
+
+      integer irythme
+      integer ierr
+      integer iq
+      integer i,j,l,zmax , ig0
+
+      integer zitau
+      character firstnom*20
+      SAVE firstnom
+      SAVE zitau
+      SAVE date
+      data firstnom /'1234567890'/
+      data zitau /0/
+
+! Ajouts
+      integer, save :: ntime=0
+      integer :: idim,varid
+      integer :: nid
+      character (len =50):: fichnom
+      integer, dimension(4) :: id
+      integer, dimension(4) :: edges,corner
+
+! added by RDW for OLR output
+       real dx3(iip1,jjp1,L_NSPECTI) ! to store the data set
+
+
+!***************************************************************
+!Sortie des variables au rythme voulu
+
+      irythme = int(ecritphy) ! sortie au rythme de ecritphy
+!     irythme = iconser  ! sortie au rythme des variables de controle
+!     irythme = iphysiq  ! sortie a tous les pas physique
+!     irythme = iecri*day_step ! sortie au rythme des fichiers histoires
+!     irythme = periodav*day_step ! sortie au rythme des fichiers histmoy
+
+!***************************************************************
+
+! The following test is here to enforce that writediagfi is not used with the
+! 1D version of the GCM
+      if (ngrid.eq.1) return
+      
+c     nom=trim((nom))
+c     unite=trim((unite))
+c     titre=trim((titre))
+
+! Initialisation of 'firstnom' and create/open the "diagfi.nc" NetCDF file
+! ------------------------------------------------------------------------
+! (Au tout premier appel de la subroutine durant le run.)
+
+      fichnom="diagspecIR.nc"
+
+      if (firstnom.eq.'1234567890') then ! .true. for the very first call
+      !  to this subroutine; now set 'firstnom'
+         firstnom = nom
+         ! just to be sure, check that firstnom is large enough to hold nom
+         if (len_trim(firstnom).lt.len_trim(nom)) then
+           write(*,*) "writediagfi: Error !!!"
+           write(*,*) "   firstnom string not long enough!!"
+           write(*,*) "   increase its size to at least ",len_trim(nom)
+           stop
+         endif
+
+         ! Create the NetCDF file
+         ierr = NF_CREATE(fichnom, NF_CLOBBER, nid)
+         ! Define the 'Time' dimension
+         ierr = nf_def_dim(nid,"Time",NF_UNLIMITED,idim)
+         ! Define the 'Time' variable
+#ifdef NC_DOUBLE
+         ierr = NF_DEF_VAR (nid, "Time", NF_DOUBLE, 1, idim,varid)
+#else
+         ierr = NF_DEF_VAR (nid, "Time", NF_FLOAT, 1, idim,varid)
+#endif
+         ! Add a long_name attribute
+         ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name",
+     .          4,"Time")
+         ! Add a units attribute
+         ierr = NF_PUT_ATT_TEXT(nid, varid,'units',29,
+     .          "days since 0000-00-0 00:00:00")
+         ! Switch out of NetCDF Define mode
+         ierr = NF_ENDDEF(nid)
+
+         ! write "header" of file (longitudes, latitudes, geopotential, ...)
+         call gr_fi_dyn(1,ngrid,iip1,jjp1,phisfi,phis)
+!         call iniwrite(nid,day_ini,phis)
+         call iniwrite_specIR(nid,day_ini,phis)
+
+         zitau = -1 ! initialize zitau
+      else
+         ! Open the NetCDF file
+         ierr = NF_OPEN(fichnom,NF_WRITE,nid)
+      endif ! if (firstnom.eq.'1234567890')
+
+! Increment time index 'zitau' if it is the "firstcall" (at given time level)
+! to writediagfi
+!------------------------------------------------------------------------
+      if (nom.eq.firstnom) then
+          zitau = zitau + iphysiq
+      end if
+
+!--------------------------------------------------------
+! Write the variables to output file if it's time to do so
+!--------------------------------------------------------
+
+      if ( MOD(zitau+1,irythme) .eq.0.) then
+
+! Compute/write/extend 'Time' coordinate (date given in days)
+! (done every "first call" (at given time level) to writediagfi)
+! Note: date is incremented as 1 step ahead of physics time
+!       (like the 'histoire' outputs)
+!--------------------------------------------------------
+
+        if (nom.eq.firstnom) then
+
+        ! We have identified a "first call" (at given date)
+           ntime=ntime+1 ! increment # of stored time steps
+           ! compute corresponding date (in days and fractions thereof)
+           date= float (zitau +1)/float (day_step)
+           ! Get NetCDF ID of 'Time' variable
+           ierr= NF_INQ_VARID(nid,"Time",varid)
+
+           !print*,'in writediagfi_spec.F, time=',varid
+
+           ! Write (append) the new date to the 'Time' array
+#ifdef NC_DOUBLE
+           ierr= NF_PUT_VARA_DOUBLE(nid,varid,ntime,1,date)
+#else
+           ierr= NF_PUT_VARA_REAL(nid,varid,ntime,1,date)
+#endif
+           if (ierr.ne.NF_NOERR) then
+              write(*,*) "***** PUT_VAR matter in writediagspec_nc"
+              write(*,*) "***** with time"
+              write(*,*) 'ierr=', ierr   
+c             call abort
+           endif
+
+           write(6,*)'WRITEDIAGSPEC: date= ', date
+        end if ! of if (nom.eq.firstnom)
+
+
+ 
+!Case of a 3D variable
+!---------------------
+        if (dim.eq.3) then
+
+!         recast (copy) variable from physics grid to dynamics grid
+           DO l=1,L_NSPECTI
+             DO i=1,iip1
+                dx3(i,1,l)=px(1,l)
+                dx3(i,jjp1,l)=px(ngrid,l)
+             ENDDO
+             DO j=2,jjm
+                ig0= 1+(j-2)*iim
+                DO i=1,iim
+                   dx3(i,j,l)=px(ig0+i,l)
+                ENDDO
+                dx3(iip1,j,l)=dx3(1,j,l)
+             ENDDO
+           ENDDO
+
+! name of the variable
+           ierr= NF_INQ_VARID(nid,nom,varid)
+           if (ierr /= NF_NOERR) then
+! corresponding dimensions
+              ierr= NF_INQ_DIMID(nid,"longitude",id(1))
+              ierr= NF_INQ_DIMID(nid,"latitude",id(2))
+              ierr= NF_INQ_DIMID(nid,"bandsIR",id(3))
+              ierr= NF_INQ_DIMID(nid,"Time",id(4))
+
+! Create the variable if it doesn't exist yet
+
+              write (*,*) "=========================="
+              write (*,*) "DIAGSPEC: creating variable ",nom
+              call def_var(nid,nom,titre,unite,4,id,varid,ierr)
+
+           endif
+
+           corner(1)=1
+           corner(2)=1
+           corner(3)=1
+           corner(4)=ntime
+
+           edges(1)=iip1
+           edges(2)=jjp1
+           edges(3)=L_NSPECTI
+           edges(4)=1
+#ifdef NC_DOUBLE
+           ierr= NF_PUT_VARA_DOUBLE(nid,varid,corner,edges,dx3)
+#else
+           ierr= NF_PUT_VARA_REAL(nid,varid,corner,edges,dx3)
+#endif
+
+           if (ierr.ne.NF_NOERR) then
+              write(*,*) "***** PUT_VAR problem in writediagspec"
+              write(*,*) "***** with ",nom
+              write(*,*) 'ierr=', ierr
+             call abort
+           endif 
+
+        endif ! of if (dim.eq.3) elseif(dim.eq.2)...
+
+      endif ! of if ( MOD(zitau+1,irythme) .eq.0.)
+
+      ierr= NF_CLOSE(nid)
+
+      end
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 305)
@@ -0,0 +1,279 @@
+      subroutine writediagspecVI(ngrid,nom,titre,unite,dim,px)
+
+!  Ecriture de variables diagnostiques au choix dans la physique 
+!  dans un fichier NetCDF nomme  'diagfi'. Ces variables peuvent etre
+!  3d (ex : temperature), 2d (ex : temperature de surface), ou
+!  0d (pour un scalaire qui ne depend que du temps : ex : la longitude
+!  solaire)
+!  Dans la version 2000, la periode d'ecriture est celle de 
+!  "ecritphy " regle dans le fichier de controle de run :  run.def
+!
+!    writediagfi peut etre appele de n'importe quelle subroutine
+!    de la physique, plusieurs fois. L'initialisation et la creation du
+!    fichier se fait au tout premier appel.
+!
+! WARNING : les variables dynamique (u,v,t,q,ps)
+!  sauvees par writediagfi avec une
+! date donnee sont legerement differentes que dans le fichier histoire car 
+! on ne leur a pas encore ajoute de la dissipation et de la physique !!!
+! IL est  RECOMMANDE d'ajouter les tendance physique a ces variables
+! avant l'ecriture dans diagfi (cf. physiq.F)
+!  
+!
+!  parametres (input) :
+!  ----------
+!      ngrid : nombres de point ou est calcule la physique
+!                (ngrid = 2+(jjm-1)*iim - 1/jjm)
+!                 (= nlon ou klon dans la physique terrestre)
+!      
+!      unit : unite logique du fichier de sortie (toujours la meme)
+!      nom  : nom de la variable a sortir (chaine de caracteres)
+!      titre: titre de la variable (chaine de caracteres)
+!      unite : unite de la variable (chaine de caracteres)
+!      px : variable a sortir (real 0, 2, ou 3d)
+!      dim : dimension de px : 0, 2, ou 3 dimensions
+!
+!=================================================================
+!
+!      This is a modified version that accepts spectrally varying input
+!      RW (2010)
+!
+!=================================================================
+ 
+! Addition by RW (2010) to allow OSR to be saved in .nc format
+      use radinc_h, only : L_NSPECTV
+
+      implicit none
+
+! Commons
+#include "dimensions.h"
+#include "dimphys.h"
+#include "paramet.h"
+#include "control.h"
+#include "comvert.h"
+#include "comgeom.h"
+#include "description.h"
+#include "netcdf.inc"
+#include "temps.h"
+#include "surfdat.h"
+
+! Arguments on input:
+      integer ngrid
+      character (len=*) :: nom,titre,unite
+      integer dim
+      real px(ngrid,L_NSPECTV)
+
+! Local variables:
+
+!      real dx3(iip1,jjp1,llm) ! to store a 3D data set
+!      real dx2(iip1,jjp1)     ! to store a 2D (surface) data set
+!      real dx0
+
+      real date
+
+      REAL phis(ip1jmp1)
+
+      integer irythme
+      integer ierr
+      integer iq
+      integer i,j,l,zmax , ig0
+
+      integer zitau
+      character firstnom*20
+      SAVE firstnom
+      SAVE zitau
+      SAVE date
+      data firstnom /'1234567890'/
+      data zitau /0/
+
+! Ajouts
+      integer, save :: ntime=0
+      integer :: idim,varid
+      integer :: nid
+      character (len =50):: fichnom
+      integer, dimension(4) :: id
+      integer, dimension(4) :: edges,corner
+
+! added by RDW for OSR output
+       real dx3(iip1,jjp1,L_NSPECTV) ! to store the data set
+
+
+!***************************************************************
+!Sortie des variables au rythme voulu
+
+      irythme = int(ecritphy) ! sortie au rythme de ecritphy
+!     irythme = iconser  ! sortie au rythme des variables de controle
+!     irythme = iphysiq  ! sortie a tous les pas physique
+!     irythme = iecri*day_step ! sortie au rythme des fichiers histoires
+!     irythme = periodav*day_step ! sortie au rythme des fichiers histmoy
+
+!***************************************************************
+
+! The following test is here to enforce that writediagfi is not used with the
+! 1D version of the GCM
+      if (ngrid.eq.1) return
+      
+c     nom=trim((nom))
+c     unite=trim((unite))
+c     titre=trim((titre))
+
+! Initialisation of 'firstnom' and create/open the "diagfi.nc" NetCDF file
+! ------------------------------------------------------------------------
+! (Au tout premier appel de la subroutine durant le run.)
+
+      fichnom="diagspecVI.nc"
+
+      if (firstnom.eq.'1234567890') then ! .true. for the very first call
+      !  to this subroutine; now set 'firstnom'
+         firstnom = nom
+         ! just to be sure, check that firstnom is large enough to hold nom
+         if (len_trim(firstnom).lt.len_trim(nom)) then
+           write(*,*) "writediagfi: Error !!!"
+           write(*,*) "   firstnom string not long enough!!"
+           write(*,*) "   increase its size to at least ",len_trim(nom)
+           stop
+         endif
+
+         ! Create the NetCDF file
+         ierr = NF_CREATE(fichnom, NF_CLOBBER, nid)
+         ! Define the 'Time' dimension
+         ierr = nf_def_dim(nid,"Time",NF_UNLIMITED,idim)
+         ! Define the 'Time' variable
+#ifdef NC_DOUBLE
+         ierr = NF_DEF_VAR (nid, "Time", NF_DOUBLE, 1, idim,varid)
+#else
+         ierr = NF_DEF_VAR (nid, "Time", NF_FLOAT, 1, idim,varid)
+#endif
+         ! Add a long_name attribute
+         ierr = NF_PUT_ATT_TEXT (nid, varid, "long_name",
+     .          4,"Time")
+         ! Add a units attribute
+         ierr = NF_PUT_ATT_TEXT(nid, varid,'units',29,
+     .          "days since 0000-00-0 00:00:00")
+         ! Switch out of NetCDF Define mode
+         ierr = NF_ENDDEF(nid)
+
+         ! write "header" of file (longitudes, latitudes, geopotential, ...)
+         call gr_fi_dyn(1,ngrid,iip1,jjp1,phisfi,phis)
+!         call iniwrite(nid,day_ini,phis)
+         call iniwrite_specVI(nid,day_ini,phis)
+
+         zitau = -1 ! initialize zitau
+      else
+         ! Open the NetCDF file
+         ierr = NF_OPEN(fichnom,NF_WRITE,nid)
+      endif ! if (firstnom.eq.'1234567890')
+
+! Increment time index 'zitau' if it is the "firstcall" (at given time level)
+! to writediagfi
+!------------------------------------------------------------------------
+      if (nom.eq.firstnom) then
+          zitau = zitau + iphysiq
+      end if
+
+!--------------------------------------------------------
+! Write the variables to output file if it's time to do so
+!--------------------------------------------------------
+
+      if ( MOD(zitau+1,irythme) .eq.0.) then
+
+! Compute/write/extend 'Time' coordinate (date given in days)
+! (done every "first call" (at given time level) to writediagfi)
+! Note: date is incremented as 1 step ahead of physics time
+!       (like the 'histoire' outputs)
+!--------------------------------------------------------
+
+        if (nom.eq.firstnom) then
+
+        ! We have identified a "first call" (at given date)
+           ntime=ntime+1 ! increment # of stored time steps
+           ! compute corresponding date (in days and fractions thereof)
+           date= float (zitau +1)/float (day_step)
+           ! Get NetCDF ID of 'Time' variable
+           ierr= NF_INQ_VARID(nid,"Time",varid)
+
+           !print*,'in writediagfi_spec.F, time=',varid
+
+           ! Write (append) the new date to the 'Time' array
+#ifdef NC_DOUBLE
+           ierr= NF_PUT_VARA_DOUBLE(nid,varid,ntime,1,date)
+#else
+           ierr= NF_PUT_VARA_REAL(nid,varid,ntime,1,date)
+#endif
+           if (ierr.ne.NF_NOERR) then
+              write(*,*) "***** PUT_VAR matter in writediagspec_nc"
+              write(*,*) "***** with time"
+              write(*,*) 'ierr=', ierr   
+c             call abort
+           endif
+
+           write(6,*)'WRITEDIAGSPEC: date= ', date
+        end if ! of if (nom.eq.firstnom)
+
+
+ 
+!Case of a 3D variable
+!---------------------
+        if (dim.eq.3) then
+
+!         recast (copy) variable from physics grid to dynamics grid
+           DO l=1,L_NSPECTV
+             DO i=1,iip1
+                dx3(i,1,l)=px(1,l)
+                dx3(i,jjp1,l)=px(ngrid,l)
+             ENDDO
+             DO j=2,jjm
+                ig0= 1+(j-2)*iim
+                DO i=1,iim
+                   dx3(i,j,l)=px(ig0+i,l)
+                ENDDO
+                dx3(iip1,j,l)=dx3(1,j,l)
+             ENDDO
+           ENDDO
+
+! name of the variable
+           ierr= NF_INQ_VARID(nid,nom,varid)
+           if (ierr /= NF_NOERR) then
+! corresponding dimensions
+              ierr= NF_INQ_DIMID(nid,"longitude",id(1))
+              ierr= NF_INQ_DIMID(nid,"latitude",id(2))
+              ierr= NF_INQ_DIMID(nid,"bandsVI",id(3))
+              ierr= NF_INQ_DIMID(nid,"Time",id(4))
+
+! Create the variable if it doesn't exist yet
+
+              write (*,*) "=========================="
+              write (*,*) "DIAGSPEC: creating variable ",nom
+              call def_var(nid,nom,titre,unite,4,id,varid,ierr)
+
+           endif
+
+           corner(1)=1
+           corner(2)=1
+           corner(3)=1
+           corner(4)=ntime
+
+           edges(1)=iip1
+           edges(2)=jjp1
+           edges(3)=L_NSPECTV
+           edges(4)=1
+#ifdef NC_DOUBLE
+           ierr= NF_PUT_VARA_DOUBLE(nid,varid,corner,edges,dx3)
+#else
+           ierr= NF_PUT_VARA_REAL(nid,varid,corner,edges,dx3)
+#endif
+
+           if (ierr.ne.NF_NOERR) then
+              write(*,*) "***** PUT_VAR problem in writediagspec"
+              write(*,*) "***** with ",nom
+              write(*,*) 'ierr=', ierr
+             call abort
+           endif 
+
+        endif ! of if (dim.eq.3) elseif(dim.eq.2)...
+
+      endif ! of if ( MOD(zitau+1,irythme) .eq.0.)
+
+      ierr= NF_CLOSE(nid)
+
+      end
